Attribute VB_Name = "modFileFuncs"
Option Explicit

Private Const MAX_PATH                 As Long = 260&
Private Const INVALID_HANDLE_VALUE     As Long = -1&

Private Declare Function GetShortPathName _
   Lib "kernel32" Alias "GetShortPathNameA" _
   (ByVal lpszLongPath As String, _
    ByVal lpszShortPath As String, _
    ByVal nBufferLength As Long) As Long
Private Declare Function OpenFile _
   Lib "kernel32" _
   (ByVal lpFileName As String, _
    lpReOpenBuff As OFSTRUCT, _
    ByVal wStyle As Long) As Long

Private Const OFS_MAXPATHNAME          As Long = 128&
Private Const OF_EXIST                 As Long = &H4000&
Private Const HFILE_ERROR              As Long = -1&

Type OFSTRUCT
   cBytes                              As Byte
   fFixedDisk                          As Byte
   nErrCode                            As Long
   Reserved1                           As Long
   Reserved2                           As Long
   szPathName(OFS_MAXPATHNAME)         As Byte
End Type

Public Function FileExists(ByVal xi_strFullPath As String) As Boolean
   Dim p_lngRtn                        As Long
   Dim p_typFilenameStruct             As OFSTRUCT
   Dim p_strShortPath                  As String
   
   p_lngRtn = OpenFile(lpFileName:=xi_strFullPath, lpReOpenBuff:=p_typFilenameStruct, wStyle:=OF_EXIST)
  
   If p_lngRtn = HFILE_ERROR Then
      p_strShortPath = GetShortName(xi_strFullPath)
        
      ' ---------------------------------------
      ' Try it again with the short path
      ' ---------------------------------------
      p_lngRtn = OpenFile(lpFileName:=p_strShortPath, _
                          lpReOpenBuff:=p_typFilenameStruct, _
                          wStyle:=OF_EXIST)
      If p_lngRtn = HFILE_ERROR Then
         FileExists = False
      Else
         FileExists = True
      End If
   Else
      FileExists = True
   End If
  
End Function

Public Function GetShortName(ByVal xi_strLongPathName As String) As String
   Dim p_strBuffer                     As String
   Dim p_lngRtn                        As Long
   
   p_strBuffer = Space$(MAX_PATH)
   If Right$(xi_strLongPathName, 1) = "\" Then
      xi_strLongPathName = Mid$(xi_strLongPathName, 1, Len(xi_strLongPathName) - 1)
   End If
   
   p_lngRtn = GetShortPathName(lpszLongPath:=xi_strLongPathName, _
                               lpszShortPath:=p_strBuffer, _
                               nBufferLength:=Len(p_strBuffer))
   If p_lngRtn > 0 Then
      GetShortName = Trim$(Mid$(p_strBuffer, 1, p_lngRtn))
   Else
      GetShortName = ""
   End If
End Function
